# -*- coding: utf-8 -*-
# Import the PyQt and QGIS libraries
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.QtSql import *
from qgis.core import *
from qgis.gui import *
from subprocess import * #Andere Programme aufrufen
import os #Zugriff aufs Betriebssystem

class featureFormHelper:
	def __init__(self, dialog, layerid, featureid):
		self.dialog = dialog
		self.layerid = layerid
		self.featureid = featureid
		
		#references to GUI elements
		self.untersuchungsDatum = self.dialog.findChild(QComboBox,"untersuchungsDatum")
		self.reinigungsDatum = self.dialog.findChild(QComboBox,"reinigungsDatum")
		self.massnDatum = self.dialog.findChild(QComboBox,"massnDatum")
		self.videoButton = self.dialog.findChild(QPushButton,"videoButton")
		self.videoPDFButton = self.dialog.findChild(QPushButton,"videoPDFButton")
		self.videoPath = ""
		self.videoPDFPath = ""
		
		#see if haltungsnr is defined and disable/enable dataver button
		self.haltungsNr = self.dialog.findChild(QLineEdit,"haltungsnr").text()
		if self.haltungsNr == 'NULL':
			self.dialog.findChild(QPushButton,"DataverStarten").setDisabled(True)
		else:
			#db connection
			self.db = QSqlDatabase.addDatabase("QPSQL")
			self.db.setHostName("myserver")
			self.db.setDatabaseName("uster")
			self.db.setUserName("www")
			self.db.setPassword("blabla")
			ok = self.db.open()
			
			if ok == False:
				QMessageBox.critical(None,"Fehler",QString("Database Connection Error: %1").arg(self.db.lastError().text()))
				return
			#untersuchungsereignisse in Combobox einfüllen
			#zuerst datum und Status abfragen und in combobox eintragen
			query = QSqlQuery(self.db)
			query.prepare("SELECT to_char(er.zeitpunkt,'YYYY-MM-DD') || ' (' || stat.wert_abkuerzung || ')' AS ausfuehrungstermin, er.zeitpunkt FROM dataver_abwasser.od_abwasserbauwerk ba LEFT JOIN dataver_abwasser.od_erhaltungsereignis er ON ba.gid = er.fs_abwasserbauwerk LEFT JOIN dataver_abwasser._status_erhaltungsereignis stat ON er.status = stat.gid WHERE ba.bezeichnung = :haltungsnr AND er.art = 7 GROUP BY er.zeitpunkt, stat.wert_abkuerzung ORDER BY er.zeitpunkt DESC;")
			query.bindValue(":haltungsnr",QVariant(QString(self.haltungsNr)))
			query.exec_()
			if query.isActive():
				counter = 0
				while query.next():
					self.untersuchungsDatum.insertItem(counter,query.value(0).toString(),query.value(1))
					counter += 1
			else:
				QMessageBox.warning(None,"Debug",QString("Database Error: %1").arg(query.lastError().text()))
				return
			query.finish()

			#Reinigungsereignisse in Combobox einfüllen
			query = QSqlQuery(self.db)
			query.prepare("SELECT to_char(er.zeitpunkt,'YYYY-MM-DD') || ' (' || stat.wert_abkuerzung || ')' AS ausfuehrungstermin, er.zeitpunkt FROM dataver_abwasser.od_abwasserbauwerk ba LEFT JOIN dataver_abwasser.od_erhaltungsereignis er ON ba.gid = er.fs_abwasserbauwerk LEFT JOIN dataver_abwasser._status_erhaltungsereignis stat ON er.status = stat.gid WHERE ba.bezeichnung = :haltungsnr AND (er.art = 4 OR er.art IS NULL) GROUP BY er.zeitpunkt, stat.wert_abkuerzung ORDER BY er.zeitpunkt DESC;")
			query.bindValue(":haltungsnr",QVariant(QString(self.haltungsNr)))
			query.exec_()
			if query.isActive():
				counter = 0
				while query.next():
					self.reinigungsDatum.insertItem(counter,query.value(0).toString(),query.value(1))
					counter += 1
			else:
				QMessageBox.warning(None,"Debug",QString("Database Error: %1").arg(query.lastError().text()))
				return
			query.finish()

			#Bauliche Massnahmen in Combobox einfüllen
			query = QSqlQuery(self.db)
			query.prepare("SELECT to_char(er.zeitpunkt,'YYYY-MM-DD') || ' (' || stat.wert_abkuerzung || ')' AS ausfuehrungstermin, er.zeitpunkt FROM dataver_abwasser.od_abwasserbauwerk ba LEFT JOIN dataver_abwasser.od_erhaltungsereignis er ON ba.gid = er.fs_abwasserbauwerk LEFT JOIN dataver_abwasser._status_erhaltungsereignis stat ON er.status = stat.gid WHERE ba.bezeichnung = :haltungsnr AND er.art IN (1,2,3,5,6) GROUP BY er.zeitpunkt, stat.wert_abkuerzung ORDER BY er.zeitpunkt DESC;")
			query.bindValue(":haltungsnr",QVariant(QString(self.haltungsNr)))
			query.exec_()
			if query.isActive():
				counter = 0
				while query.next():
					self.massnDatum.insertItem(counter,query.value(0).toString(),query.value(1))
					counter += 1
			else:
				QMessageBox.warning(None,"Debug",QString("Database Error: %1").arg(query.lastError().text()))
				return
			query.finish()
			
			QObject.connect(self.untersuchungsDatum,SIGNAL("currentIndexChanged(int)"),self.untersuchungSelected)
			QObject.connect(self.reinigungsDatum,SIGNAL("currentIndexChanged(int)"),self.reinigungSelected)
			QObject.connect(self.massnDatum,SIGNAL("currentIndexChanged(int)"),self.massnSelected)
			QObject.connect(self.videoButton,SIGNAL("clicked(bool)"),self.videoButtonClicked)
			QObject.connect(self.videoPDFButton,SIGNAL("clicked(bool)"),self.videoPDFButtonClicked)
			self.untersuchungsDatum.setCurrentIndex(0)
			self.untersuchungSelected(0)
			self.reinigungsDatum.setCurrentIndex(0)
			self.reinigungSelected(0)
			self.massnDatum.setCurrentIndex(0)
			self.massnSelected(0)
	
	def untersuchungSelected(self,untersuchungsDatumIndex):
		timestamp = self.untersuchungsDatum.itemData(untersuchungsDatumIndex,Qt.UserRole).toString()
		#QMessageBox.warning(None,"Debug",QString("Untersuchungsdatum: %1").arg(timestamp))
		#Zusammenzug von verschiedenen Dataver Untersuchungsangaben, Art 7=Untersuchung
		sqlUntersuchung = "SELECT unt.obj_id AS unt_id, aufn_art.wert AS untersuchungsart, org_ausf.bezeichnung AS ausfuehrende_firma, dyn_operat.attkey AS operateur, dyn_kamtyp.attkey AS kameratyp, to_char(er.zeitpunkt,'YYYY-MM-DD') AS aufnahmezeitpunkt, dyn_witt.attkey AS witterung, dyn_ausw.attkey AS auswerteperson, to_char(unt.auswertedatum,'YYYY-MM-DD') AS auswertedatum, er.bemerkung AS bemerkung_ereignis, baStart.bezeichnung AS startbauwerk, er_status.wert AS status_auswertung, bazust.wert AS rohrzustand, sanbed.wert AS sanierungsbedarf_dataver, unt.inspizierte_laenge AS inspiziert_m, unt.nichtinspiziert AS nicht_inspiziert_m, sanver1.wert AS sanierungsvorschlag, untplanvorschlel1.kostenvoranschlag AS sanierungskosten, sanver2.wert AS sanierungsvorschlag_alternativ, untplanvorschlel2.kostenvoranschlag AS sanierungskosten_alternativ FROM dataver_abwasser.od_abwasserbauwerk ba LEFT JOIN dataver_abwasser.od_erhaltungsereignis er ON ba.gid = er.fs_abwasserbauwerk LEFT JOIN dataver_abwasser.od_untersuchung unt ON er.gid = unt.obj_id LEFT JOIN dataver_abwasser._aufnahmeart_untersuchung aufn_art ON unt.aufnahmeart = aufn_art.gid LEFT JOIN dataver_abwasser.od_organisation org_ausf ON er.fs_ausfuehrender = org_ausf.gid LEFT JOIN dataver_abwasser.od_wertebereichdynamischwerte dyn_operat ON unt.fs_operateur = dyn_operat.obj_id LEFT JOIN dataver_abwasser.od_wertebereichdynamischwerte dyn_kamtyp ON unt.fs_kameratyp = dyn_kamtyp.obj_id LEFT JOIN dataver_abwasser.od_wertebereichdynamischwerte dyn_witt ON unt.fs_witterung = dyn_witt.obj_id LEFT JOIN dataver_abwasser.od_wertebereichdynamischwerte dyn_ausw ON unt.fs_auswerteperson = dyn_ausw.obj_id LEFT JOIN dataver_abwasser._status_erhaltungsereignis er_status ON er.status = er_status.gid LEFT JOIN dataver_abwasser._sanierungsbedarf sanbed ON unt.sanierungsbedarf = sanbed.gid LEFT JOIN dataver_abwasser.od_unterhaltsplanung untplan ON unt.obj_id = untplan.fs_untersuchung LEFT JOIN dataver_abwasser.od_unterhaltsvorschlag untplanvorschl1 ON untplan.obj_id = untplanvorschl1.fs_unterhaltsplanung AND untplanvorschl1.reihenfolge = 1 LEFT JOIN dataver_abwasser.od_unterhaltsvorschlagelement untplanvorschlel1 ON untplanvorschl1.obj_id = untplanvorschlel1.fs_unterhaltsvorschlag LEFT JOIN dataver_abwasser._sanierungsverfahren sanver1 ON untplanvorschlel1.bautechnik = sanver1.gid LEFT JOIN dataver_abwasser.od_unterhaltsvorschlag untplanvorschl2 ON untplan.obj_id = untplanvorschl2.fs_unterhaltsplanung AND untplanvorschl2.reihenfolge = 2 LEFT JOIN dataver_abwasser.od_unterhaltsvorschlagelement untplanvorschlel2 ON untplanvorschl2.obj_id = untplanvorschlel2.fs_unterhaltsvorschlag LEFT JOIN dataver_abwasser._sanierungsverfahren sanver2 ON untplanvorschlel2.bautechnik = sanver2.gid LEFT JOIN dataver_abwasser.od_haltungspunkt hpkt ON unt.fs_haltungspunkt = hpkt.obj_id LEFT JOIN dataver_abwasser.od_abwassernetzelement netzel ON hpkt.fs_abwassernetzelement = netzel.gid LEFT JOIN dataver_abwasser.od_abwasserbauwerk baStart ON netzel.fs_abwasserbauwerk = baStart.gid LEFT JOIN dataver_abwasser._baulicher_zustand bazust ON unt.baulicherzustand = bazust.gid WHERE ba.bezeichnung = :haltungsnr AND er.art = 7 AND er.zeitpunkt = :timestamp;"
		query = QSqlQuery(self.db)
		query.prepare(sqlUntersuchung)
		query.bindValue(":haltungsnr",QVariant(QString(self.haltungsNr)))
		query.bindValue(":timestamp",QVariant(QString(timestamp)))
		query.exec_()
		if query.isActive():
			query.first()
			unt_id,untersuchungsart,ausfuehrende_firma,operateur,kameratyp,aufnahmezeitpunkt,witterung,auswerteperson,auswertedatum,bemerkung_ereignis,startbauwerk,status_auswertung,rohrzustand,sanierungsbedarf_dataver,inspiziert_m,nicht_inspiziert_m,sanierungsvorschlag,sanierungskosten,sanierungsvorschlag_alternativ,sanierungskosten_alternativ = range(20)
			self.unt_id = query.value(unt_id).toString() #obj_id der Untersuchung - wichtig um Detailschäden zu linken
			self.dialog.findChild(QLineEdit,"untersuchungsart").setText(QString(query.value(untersuchungsart).toString()))
			self.dialog.findChild(QLineEdit,"ausfuehrende_firma").setText(QString(query.value(ausfuehrende_firma).toString()))
			self.dialog.findChild(QLineEdit,"operateur").setText(QString(query.value(operateur).toString()))
			self.dialog.findChild(QLineEdit,"kameratyp").setText(QString(query.value(kameratyp).toString()))
			self.dialog.findChild(QLineEdit,"aufnahmezeitpunkt").setText(QString(query.value(aufnahmezeitpunkt).toString()))
			self.dialog.findChild(QLineEdit,"witterung").setText(QString(query.value(witterung).toString()))
			self.dialog.findChild(QLineEdit,"auswerteperson").setText(QString(query.value(auswerteperson).toString()))
			self.dialog.findChild(QLineEdit,"auswertedatum").setText(QString(query.value(auswertedatum).toString()))
			self.dialog.findChild(QPlainTextEdit,"bemerkung_ereignis").setPlainText(QString(query.value(bemerkung_ereignis).toString()))
			self.dialog.findChild(QLineEdit,"startbauwerk").setText(QString(query.value(startbauwerk).toString()))
			self.dialog.findChild(QLineEdit,"status_auswertung").setText(QString(query.value(status_auswertung).toString()))
			self.dialog.findChild(QLineEdit,"rohrzustand").setText(QString(query.value(rohrzustand).toString()))
			self.dialog.findChild(QLineEdit,"sanierungsbedarf_dataver").setText(QString(query.value(sanierungsbedarf_dataver).toString()))
			self.dialog.findChild(QLineEdit,"inspiziert_m").setText(QString(query.value(inspiziert_m).toString()))
			self.dialog.findChild(QLineEdit,"nicht_inspiziert_m").setText(QString(query.value(nicht_inspiziert_m).toString()))
			self.dialog.findChild(QLineEdit,"sanierungsvorschlag").setText(QString(query.value(sanierungsvorschlag).toString()))
			self.dialog.findChild(QLineEdit,"sanierungskosten").setText(QString(query.value(sanierungskosten).toString()))
			self.dialog.findChild(QLineEdit,"sanierungsvorschlag_alternativ").setText(QString(query.value(sanierungsvorschlag_alternativ).toString()))
			self.dialog.findChild(QLineEdit,"sanierungskosten_alternativ").setText(QString(query.value(sanierungskosten_alternativ).toString()))
		else:
			QMessageBox.warning(None,"Debug",QString("Database Error: %1").arg(query.lastError().text()))
			return
		query.finish()
			
		#Video abfragen
		sqlVideo = "SELECT dat.bezeichnung AS dateiname, datext.pfad FROM dataver_abwasser.od_abwasserbauwerk ba LEFT JOIN dataver_abwasser.od_erhaltungsereignis er ON ba.gid = er.fs_abwasserbauwerk LEFT JOIN dataver_abwasser.od_datei dat ON er.gid = dat.datensatz LEFT JOIN dataver_abwasser.od_dateiextern datext ON dat.gid = datext.obj_id WHERE ba.bezeichnung = :haltungsnr AND er.art = 7 AND er.zeitpunkt = :timestamp ORDER BY er.zeitpunkt;"
		query = QSqlQuery(self.db)
		query.prepare(sqlVideo)
		query.bindValue(":haltungsnr",QVariant(QString(self.haltungsNr)))
		query.bindValue(":timestamp",QVariant(QString(timestamp)))

		query.exec_()
		if query.isActive():
			query.first()
			dateiname,pfad = range(2)
			dateiname = query.value(dateiname).toString()
			pfad = query.value(pfad).toString()
			if len(dateiname) > 4: #könnte mpg-Datei sein
				if dateiname.endsWith(".mpg",Qt.CaseInsensitive):
					#mpg-Datei abchecken
					self.videoPath = "\\\\myserver\stadtentwaesserung"+pfad+"\\"+dateiname
					if os.path.isfile(self.videoPath):
						self.videoButton.setText("Video starten")
						self.videoButton.setDisabled(False)
					else:
						self.videoButton.setText("Videodatei fehlt")
						self.videoButton.setDisabled(True)
					#PDF Protokolldatei abchecken
					self.videoPDFPath = "\\\\myserver\stadtentwaesserung"+pfad+"\\"+dateiname
					self.videoPDFPath.replace(".mpg",".pdf")
					if os.path.isfile(self.videoPDFPath):
						self.videoPDFButton.setText("PDF starten")
						self.videoPDFButton.setDisabled(False)
					else:
						self.videoPDFButton.setText("PDF-Datei fehlt")
						self.videoPDFButton.setDisabled(True)						
				else:
					#analoge Videos
					self.videoButton.setText(QString("VHS "+dateiname))
					self.videoButton.setDisabled(True)
					self.videoPDFButton.setText(QString(u"Kein PDF verfügbar"))
					self.videoPDFButton.setDisabled(True)
			else:
				self.videoButton.setText(u"Kein Video verfügbar")
				self.videoButton.setDisabled(True)
				self.videoPDFButton.setText(u"Kein PDF verfügbar")
				self.videoPDFButton.setDisabled(True)
		
		query.finish()
		
		#Detailschäden/Beobachtungen abfragen
		self.haltungsschDetModel = QSqlTableModel()
		gid, distanz, videozaehlerstand, schadencode, kek_text, schadenlage1, schadenlage2, quantifizierung1, quantifizierung2, streckenschaden, verbindung, bemerkung, schadenwert, schadenprioritaet = range(14)
		self.haltungsschDetModel.setTable("dataver_abwasser.details_haltungsschaeden")
		self.haltungsschDetModel.setFilter("fs_untersuchung = '"+self.unt_id+"'")
		self.haltungsschDetModel.removeColumn(1) #fs_untersuchung unterdrücken
		self.haltungsschDetModel.setSort(gid,Qt.AscendingOrder)
		self.haltungsschDetModel.setHeaderData(distanz, Qt.Horizontal, QVariant("Dist"))
		self.haltungsschDetModel.setHeaderData(videozaehlerstand, Qt.Horizontal, QVariant("Zeit"))
		self.haltungsschDetModel.setHeaderData(schadencode, Qt.Horizontal, QVariant("Code"))
		self.haltungsschDetModel.setHeaderData(kek_text, Qt.Horizontal, QVariant("KEK Text"))
		self.haltungsschDetModel.setHeaderData(schadenlage1, Qt.Horizontal, QVariant("L1"))
		self.haltungsschDetModel.setHeaderData(schadenlage2, Qt.Horizontal, QVariant("L2"))
		self.haltungsschDetModel.setHeaderData(quantifizierung1, Qt.Horizontal, QVariant("Q1"))
		self.haltungsschDetModel.setHeaderData(quantifizierung2, Qt.Horizontal, QVariant("Q2"))
		self.haltungsschDetModel.setHeaderData(streckenschaden, Qt.Horizontal, QVariant("St"))
		self.haltungsschDetModel.setHeaderData(verbindung, Qt.Horizontal, QVariant("V"))
		self.haltungsschDetModel.setHeaderData(bemerkung, Qt.Horizontal, QVariant("Bemerkung"))
		self.haltungsschDetModel.setHeaderData(schadenwert, Qt.Horizontal, QVariant("Wert"))
		self.haltungsschDetModel.setHeaderData(schadenprioritaet, Qt.Horizontal, QVariant("Prio"))
		self.haltungsschDetModel.select()
		
		self.haltungsschDetView =  self.dialog.findChild(QTableView,"haltungsSchaedenDetailTabelle")
		self.haltungsschDetView.setModel(self.haltungsschDetModel)
		self.haltungsschDetView.setSelectionMode(QTableView.SingleSelection)
		self.haltungsschDetView.setSelectionBehavior(QTableView.SelectRows)
		self.haltungsschDetView.setColumnHidden(gid,True) #hide gid column
		self.haltungsschDetView.resizeColumnsToContents()
	
	def reinigungSelected(self,reinigungsDatumIndex):
		timestamp = self.reinigungsDatum.itemData(reinigungsDatumIndex,Qt.UserRole).toString()
		sqlReinigung = "SELECT to_char(er.zeitpunkt,'YYYY-MM-DD') AS reinZeitpunkt, org_ausf.bezeichnung AS reinAusfuehrender, er_status.wert AS reinStatus, spuelinfo.wert AS reinSpuelinformation, reinw.wert AS reinWerkzeug, er.dauer AS reinDauer, er.ergebnis AS reinErgebnis, er.grund as reinGrund, er.kosten AS reinKosten, er.kontonummer AS reinKontonr, rein.spuelhinweis AS reinSpuelhinweis, er.bemerkung AS reinBemerkung FROM dataver_abwasser.od_abwasserbauwerk ba LEFT JOIN dataver_abwasser.od_erhaltungsereignis er ON ba.gid = er.fs_abwasserbauwerk LEFT JOIN dataver_abwasser.od_reinigung rein ON er.gid = rein.obj_id LEFT JOIN dataver_abwasser.od_organisation org_ausf ON er.fs_ausfuehrender = org_ausf.gid LEFT JOIN dataver_abwasser._status_erhaltungsereignis er_status ON er.status = er_status.gid LEFT JOIN dataver_abwasser._spuelinformationen spuelinfo ON rein.spuelinformation = spuelinfo.gid LEFT JOIN dataver_abwasser._reinigungswerkzeuge reinw ON rein.reinigungswerkzeug = reinw.gid WHERE ba.bezeichnung = :haltungsnr AND (er.art = 4 OR (er.art IS NULL)) AND er.zeitpunkt = :timestamp;"
		query = QSqlQuery(self.db)
		query.prepare(sqlReinigung)
		query.bindValue(":haltungsnr",QVariant(QString(self.haltungsNr)))
		query.bindValue(":timestamp",QVariant(QString(timestamp)))
		query.exec_()
		if query.isActive():
			query.first()
			reinZeitpunkt,reinAusfuehrender,reinStatus,reinSpuelinformation,reinWerkzeug,reinDauer,reinErgebnis,reinGrund,reinKosten,reinKontonr,reinSpuelhinweis,reinBemerkung = range(12)
			self.dialog.findChild(QLineEdit,"reinZeitpunkt").setText(QString(query.value(reinZeitpunkt).toString()))
			self.dialog.findChild(QLineEdit,"reinAusfuehrender").setText(QString(query.value(reinAusfuehrender).toString()))
			self.dialog.findChild(QLineEdit,"reinStatus").setText(QString(query.value(reinStatus).toString()))
			self.dialog.findChild(QLineEdit,"reinSpuelinformation").setText(QString(query.value(reinSpuelinformation).toString()))
			self.dialog.findChild(QLineEdit,"reinWerkzeug").setText(QString(query.value(reinWerkzeug).toString()))
			self.dialog.findChild(QLineEdit,"reinDauer").setText(QString(query.value(reinDauer).toString()))
			self.dialog.findChild(QLineEdit,"reinErgebnis").setText(QString(query.value(reinErgebnis).toString()))
			self.dialog.findChild(QLineEdit,"reinGrund").setText(QString(query.value(reinGrund).toString()))
			self.dialog.findChild(QLineEdit,"reinKosten").setText(QString(query.value(reinKosten).toString()))
			self.dialog.findChild(QLineEdit,"reinKontonr").setText(QString(query.value(reinKontonr).toString()))
			self.dialog.findChild(QPlainTextEdit,"reinSpuelhinweis").setPlainText(QString(query.value(reinSpuelhinweis).toString()))
			self.dialog.findChild(QPlainTextEdit,"reinBemerkung").setPlainText(QString(query.value(reinBemerkung).toString()))
		else:
			QMessageBox.warning(None,"Debug",QString("Database Error: %1").arg(query.lastError().text()))
			return
		query.finish()

	def massnSelected(self,massnDatumIndex):
		timestamp = self.massnDatum.itemData(massnDatumIndex,Qt.UserRole).toString()
		sqlBauuh = "SELECT  er.bezeichnung AS massnBezeichnung, to_char(er.zeitpunkt,'YYYY-MM-DD') AS massnZeitpunkt, er_art.wert AS massnArt, org_ausf.bezeichnung AS massnAusfuehrender, er.datengrundlage AS massnDatengrundlage, bau.garantiefrist AS massnGarantiefrist, er_status.wert AS massnStatus, er.dauer AS massnDauer, er.detaildaten AS massnDetaildaten, er.ergebnis AS massnErgebnis, er.grund AS massnGrund, er.kontonummer AS massnKontonummer, bau.kostenvoranschlag AS massnKostenvoranschlag, er.kosten AS massnKostentats, '-' AS massnMassnahmen, sanver1.wert AS massnSanvorschlag, untplanvorschlel1.kostenvoranschlag AS massnKostenvorschl1, sanver2.wert AS massnSanvorschlagAlternativ, untplanvorschlel2.kostenvoranschlag AS massnKostenvorschl2, er.bemerkung AS massnBemerkung FROM dataver_abwasser.od_abwasserbauwerk ba LEFT JOIN dataver_abwasser.od_erhaltungsereignis er ON ba.gid = er.fs_abwasserbauwerk LEFT JOIN dataver_abwasser.od_bau bau ON er.gid = bau.obj_id LEFT JOIN dataver_abwasser.od_organisation org_ausf ON er.fs_ausfuehrender = org_ausf.gid LEFT JOIN dataver_abwasser._status_erhaltungsereignis er_status ON er.status = er_status.gid LEFT JOIN dataver_abwasser._art_erhaltungsereignis er_art ON er.art = er_art.gid LEFT JOIN dataver_abwasser.od_unterhaltsplanung untplan ON bau.fs_unterhaltsplanung = untplan.fs_untersuchung LEFT JOIN dataver_abwasser.od_unterhaltsvorschlag untplanvorschl1 ON untplan.obj_id = untplanvorschl1.fs_unterhaltsplanung AND untplanvorschl1.reihenfolge = 1 LEFT JOIN dataver_abwasser.od_unterhaltsvorschlagelement untplanvorschlel1 ON untplanvorschl1.obj_id = untplanvorschlel1.fs_unterhaltsvorschlag LEFT JOIN dataver_abwasser._sanierungsverfahren sanver1 ON untplanvorschlel1.bautechnik = sanver1.gid LEFT JOIN dataver_abwasser.od_unterhaltsvorschlag untplanvorschl2 ON untplan.obj_id = untplanvorschl2.fs_unterhaltsplanung AND untplanvorschl2.reihenfolge = 2 LEFT JOIN dataver_abwasser.od_unterhaltsvorschlagelement untplanvorschlel2 ON untplanvorschl2.obj_id = untplanvorschlel2.fs_unterhaltsvorschlag LEFT JOIN dataver_abwasser._sanierungsverfahren sanver2 ON untplanvorschlel2.bautechnik = sanver2.gid WHERE ba.bezeichnung = :haltungsnr AND er.art IN (1,2,3,5,6)  AND er.zeitpunkt = :timestamp ORDER BY er.zeitpunkt DESC;"
		query = QSqlQuery(self.db)
		query.prepare(sqlBauuh)
		query.bindValue(":haltungsnr",QVariant(QString(self.haltungsNr)))
		query.bindValue(":timestamp",QVariant(QString(timestamp)))
		query.exec_()
		if query.isActive():
			query.first()
			massnBezeichnung,massnZeitpunkt,massnArt,massnAusfuehrender,massnDatengrundlage,massnGarantiefrist,massnStatus,massnDauer,massnDetaildaten,massnErgebnis,massnGrund,massnKontonummer,massnKostenvoranschlag,massnKostentats,massnMassnahmen,massnSanvorschlag,massnKostenvorschl1,massnSanvorschlagAlternativ,massnKostenvorschl2,massnBemerkung = range(20)
			self.dialog.findChild(QLineEdit,"massnBezeichnung").setText(QString(query.value(massnBezeichnung).toString()))
			self.dialog.findChild(QLineEdit,"massnZeitpunkt").setText(QString(query.value(massnZeitpunkt).toString()))
			self.dialog.findChild(QLineEdit,"massnArt").setText(QString(query.value(massnArt).toString()))
			self.dialog.findChild(QLineEdit,"massnAusfuehrender").setText(QString(query.value(massnAusfuehrender).toString()))
			self.dialog.findChild(QLineEdit,"massnDatengrundlage").setText(QString(query.value(massnDatengrundlage).toString()))
			self.dialog.findChild(QLineEdit,"massnGarantiefrist").setText(QString(query.value(massnGarantiefrist).toString()))
			self.dialog.findChild(QLineEdit,"massnStatus").setText(QString(query.value(massnStatus).toString()))
			self.dialog.findChild(QLineEdit,"massnDauer").setText(QString(query.value(massnDauer).toString()))
			self.dialog.findChild(QLineEdit,"massnDetaildaten").setText(QString(query.value(massnDetaildaten).toString()))
			self.dialog.findChild(QLineEdit,"massnErgebnis").setText(QString(query.value(massnErgebnis).toString()))
			self.dialog.findChild(QLineEdit,"massnGrund").setText(QString(query.value(massnGrund).toString()))
			self.dialog.findChild(QLineEdit,"massnKontonummer").setText(QString(query.value(massnKontonummer).toString()))
			self.dialog.findChild(QLineEdit,"massnKostenvoranschlag").setText(QString(query.value(massnKostenvoranschlag).toString()))
			self.dialog.findChild(QLineEdit,"massnKostentats").setText(QString(query.value(massnKostentats).toString()))
			self.dialog.findChild(QLineEdit,"massnMassnahmen").setText(QString(query.value(massnMassnahmen).toString()))
			self.dialog.findChild(QLineEdit,"massnSanvorschlag").setText(QString(query.value(massnSanvorschlag).toString()))
			self.dialog.findChild(QLineEdit,"massnKostenvorschl1").setText(QString(query.value(massnKostenvorschl1).toString()))
			self.dialog.findChild(QLineEdit,"massnSanvorschlagAlternativ").setText(QString(query.value(massnSanvorschlagAlternativ).toString()))
			self.dialog.findChild(QLineEdit,"massnKostenvorschl2").setText(QString(query.value(massnKostenvorschl2).toString()))
			self.dialog.findChild(QPlainTextEdit,"massnBemerkung").setPlainText(QString(query.value(massnBemerkung).toString()))
		else:
			QMessageBox.warning(None,"Debug",QString("Database Error: %1").arg(query.lastError().text()))
			return
		query.finish()
		
	def videoButtonClicked(self):
		command = "C:\\Programme\\VideoLAN\\VLC\\vlc.exe"
		pid = Popen([command, str(self.videoPath)]).pid
	
	def videoPDFButtonClicked(self):
		command = "C:\\Programme\\Adobe\\Reader 9.0\\Reader\\AcroRd32.exe"
		pid = Popen([command, str(self.videoPDFPath)]).pid

def featureFormInit(dialog,layerid,featureid):
	dialog.setProperty( "helper", featureFormHelper(dialog, layerid, featureid) )
