# -*- coding: utf-8 -*-
# Import the PyQt and QGIS libraries
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.QtSql import *
from qgis.core import *
from qgis.gui import *

def featureFormInit(dialog,layerid,featureid):
    #see if schachtnummer is defined and disable/enable dataver button
	schachtnummer = dialog.findChild(QLineEdit,"schachtnummer").text()
	#QMessageBox.warning(None,"Debug","schachtnummer="+schachtnummer)
	if schachtnummer == 'NULL':
		dialog.findChild(QPushButton,"DataverStarten").setDisabled(True)
	
	#db connection
	db = QSqlDatabase.addDatabase("QPSQL")
	db.setHostName("myserver")
	db.setDatabaseName("uster")
	db.setUserName("www")
	db.setPassword("blabla")
	ok = db.open()
	
	if ok == False:
		QMessageBox.critical(None,"Fehler","Datenbankverbindung fehlgeschlagen")
		return
	
	#Deckel in Tabelle einfüllen
	sqlCover = "SELECT deckelnr, deckelhoehe, deckelform, dimension_1, dimension_2, belueftungsart, deckelmaterial, verschlussart FROM abwasser.deckel WHERE fid_schacht_bauwerk = "+dialog.findChild(QLineEdit,"gid_normschacht").text()+";"
	deckelQueryModel = QSqlQueryModel()
	deckelQueryModel.setQuery(sqlCover,db)
	deckelQueryModel.setHeaderData(0, Qt.Horizontal, QVariant("Deckelnr"))
	deckelQueryModel.setHeaderData(1, Qt.Horizontal, QVariant(u"Deckelhöhe"))
	deckelQueryModel.setHeaderData(2, Qt.Horizontal, QVariant("Deckelform"))
	deckelQueryModel.setHeaderData(3, Qt.Horizontal, QVariant("Dimension1"))
	deckelQueryModel.setHeaderData(4, Qt.Horizontal, QVariant("Dimension2"))
	deckelQueryModel.setHeaderData(5, Qt.Horizontal, QVariant(u"Belüftung"))
	deckelQueryModel.setHeaderData(6, Qt.Horizontal, QVariant("Material"))
	deckelQueryModel.setHeaderData(7, Qt.Horizontal, QVariant("Verschlussart"))
	deckelTableView = dialog.findChild(QTableView,"coverTable")
	deckelTableView.setModel(deckelQueryModel)
	deckelTableView.resizeColumnsToContents()
	deckelTableView.show()

	#Eingehende Haltungen einfüllen
	sqlEinlauf = "SELECT s.output_z AS einlaufhoehe,s.name_number AS haltungsnr,s.gid as gid_haltung FROM abw_topobase.ww_point p, abw_topobase.ww_line l, abw_topobase.ww_section s WHERE p.fid_attr = "+dialog.findChild(QLineEdit,"gid_normschacht").text()+" AND s.gid = l.fid_attr AND EXISTS (SELECT 1 FROM abw_topobase.ww_conn c WHERE c.fid_to = p.gid AND c.flow = 1 AND c.fid_from = l.gid UNION ALL SELECT 1 FROM abw_topobase.ww_conn c WHERE c.fid_from = p.gid AND c.flow = 2 AND c.fid_to = l.gid);"
	#QMessageBox.warning(None,"Debug","sql="+sqlEinlauf)
	einlaufQueryModel = QSqlQueryModel()
	einlaufQueryModel.setQuery(sqlEinlauf,db)
	einlaufQueryModel.setHeaderData(0, Qt.Horizontal, QVariant(u"Einlaufhöhe"))
	einlaufQueryModel.setHeaderData(1, Qt.Horizontal, QVariant("HaltungsNr"))
	einlaufQueryModel.setHeaderData(2, Qt.Horizontal, QVariant("GID Haltung"))
	einlaufTableView = dialog.findChild(QTableView,"einlaufTable")
	einlaufTableView.setModel(einlaufQueryModel)
	einlaufTableView.resizeColumnsToContents()
	einlaufTableView.show()

	#Ausgehende Haltungen einfüllen
	sqlAuslauf = "SELECT s.input_z AS auslaufhoehe,s.name_number AS haltungsnr,s.gid as gid_haltung FROM abw_topobase.ww_point p, abw_topobase.ww_line l, abw_topobase.ww_section s WHERE p.fid_attr = "+dialog.findChild(QLineEdit,"gid_normschacht").text()+" AND s.gid = l.fid_attr AND EXISTS (SELECT 1 FROM abw_topobase.ww_conn c WHERE c.fid_from = p.gid AND c.flow = 1 AND c.fid_to = l.gid UNION ALL SELECT 1 FROM abw_topobase.ww_conn c WHERE c.fid_to = p.gid AND c.flow = 2 AND c.fid_from = l.gid);"
	#QMessageBox.warning(None,"Debug","sql="+sqlEinlauf)
	auslaufQueryModel = QSqlQueryModel()
	auslaufQueryModel.setQuery(sqlAuslauf,db)
	auslaufQueryModel.setHeaderData(0, Qt.Horizontal, QVariant(u"Auslaufhöhe"))
	auslaufQueryModel.setHeaderData(1, Qt.Horizontal, QVariant("HaltungsNr"))
	auslaufQueryModel.setHeaderData(2, Qt.Horizontal, QVariant("GID Haltung"))
	auslaufTableView = dialog.findChild(QTableView,"auslaufTable")
	auslaufTableView.setModel(auslaufQueryModel)
	auslaufTableView.resizeColumnsToContents()
	auslaufTableView.show()